stages:
- build-and-test
- dockerize-application
- deploy-testing

variables:
  PIPELINE_TESTING_WEBHOOK: "https://gitlab.com/api/v4/projects/7674019/trigger/pipeline"

build-and-test:
  stage: build-and-test
  image: openjdk:10-slim
  script:
  # install additional components fo image
  - apt-get update && apt-get install -y git
  # build, test and publish service and cdct-stubs
  - chmod +x ./gradlew
  - ./gradlew build publish
  - ls ./build/libs
  - ./gradlew sonarqube || true # failure of sonarqube should not lead to failure of the build stage
  artifacts:
    when: always
    paths:
    - build/reports/
    - build/libs/
    - Dockerfile
  only:
  - master

dockerize-application:
  stage: dockerize-application
  image: docker:stable
  variables:
    DOCKER_HOST: tcp://docker:2375
    DOCKER_DRIVER: overlay2
  services:
  - docker:dind
  script:
  - export SERVICE_JAR_FILE="./build/libs/`ls ./build/libs | grep -v stubs`"
  - printf "Service-jar path is \"$SERVICE_JAR_FILE\"\n"
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker build --build-arg JAR_FILE=$SERVICE_JAR_FILE --tag $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .
  - docker push $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID
  - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  - docker push $CI_REGISTRY_IMAGE:latest
  dependencies:
  - build-and-test
  only:
  - master

#dockerize-application:
#  stage: dockerize-application
#  image:
#    name: gcr.io/kaniko-project/executor:debug
#    entrypoint: [""]
#  script:
#  - export SERVICE_JAR_FILE="./build/libs/`ls ./build/libs | grep -v stubs`"
#  - printf "Service-jar path is \"$SERVICE_JAR_FILE\"\n"
#  # create docker image and push to gitlab registry
#  - mkdir -p /root/.docker
#  - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /root/.docker/config.json
#  - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --build-arg JAR_FILE=$SERVICE_JAR_FILE --destination $CI_REGISTRY_IMAGE:$CI_PIPELINE_ID --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --destination $CI_REGISTRY_IMAGE:latest
#  dependencies:
#  - build-and-test
#  only:
#  - master

deploy-testing:
  stage: deploy-testing
  image: alpine:latest
  variables:
    GIT_STRATEGY: none
  before_script:
  - apk add --no-cache curl
  script:
  - curl -X POST -F token=$PIPELINE_TESTING_TOKEN -F ref=master -F variables[TRIGGER_INTEGRATIONTEST]=true $PIPELINE_TESTING_WEBHOOK
  dependencies:
  - dockerize-application
  only:
  - master
